#ifndef __ACTIVEDISKIMPL_H__
#define __ACTIVEDISKIMPL_H__

#include <UserModules/UserModules.h>
#include <vector>

class CActiveDisk
{
public:
   CActiveDisk();
   ~CActiveDisk();

   void SetInitParams(INTEROP_COUNT _numParameters, const FVDLL_PARAMETER* _pParameters);
   void LoadParameters(INTEROP_COUNT _numParameters, const FVDLL_PARAMETER* _pParameters);
   void SaveParameters();

   void InitDisk(FVAPI_BCONDITION _hBCond1, FVAPI_BCONDITION _hBCond2);
   void BeforeTimeStep();
   void AfterTimeStep();
   void GetValueInContext(FVAPI_VARIABLE _hVariable, FVAPI_CONTEXT _hVarContext, INTEROP_DOUBLE* _outValue);

protected:
   void CheckRes(INTEROP_RESULT _res) { if (_res != INTEROP_OK) throw _res; }
   double GetDeltaPres(double &_vel, double _time);

protected:
   FVAPI_BCONDITION m_BConditions[2]; // [0] - inlet, [1] - outlet
   FVAPI_SUBREGION m_Subregions[2];
   FVAPI_GRID m_Grid[2];

   FVAPI_VARIABLE m_Velocity, m_Pressure, m_Temperature, m_Density;

   double m_Frequency, m_DeltaTemp;
   std::vector<double> m_J, m_Kt;
   double normMassVel, pressValue, deltaPres, tempValue;
};

#endif
