#ifndef __SINUSEVALUATORIMPL_H__
#define __SINUSEVALUATORIMPL_H__

#include <UserModules/UserModules.h>

class CSinusEvaluator
{
public:

   enum EFunctionType
   {
      SINUS,
      COSINUS
   };

   // Struct of scaling factors
   struct SScale
   {
      SScale(double _X, double _Y, double _Z) : X(_X), Y(_Y), Z(_Z) {}
      double X, Y, Z;
   };

   CSinusEvaluator();
   ~CSinusEvaluator();

   void SetInitParams(INTEROP_COUNT _numParameters, const FVDLL_PARAMETER* _pParameters);

   // Evaluate scalar value
   INTEROP_DOUBLE EvaluateScalar(FVAPI_CONTEXT _hVarContext);

protected:
   EFunctionType m_Function; // Function type: sinus or cosinus
   SScale m_Scale;
   double m_Amplitude;
   double m_Frequency;

   // Auxiliary result check function
   void CheckRes(INTEROP_RESULT _res) { if (_res != INTEROP_OK) throw _res; }
};

#endif // __SINUSEVALUATORIMPL_H__
