#ifndef __INTEROP_CODES_H__
#define __INTEROP_CODES_H__

#include "interop_types.h"

#ifdef __cplusplus
extern "C" 
{
#endif

enum { _INTEROP_ERROR_GROUP_SHIFT = 24 };
enum { _INTEROP_ERROR_GROUP_MASK = 0xFFU << _INTEROP_ERROR_GROUP_SHIFT };

enum {
   INTEROP_ERROR_GROUP_GENERIC      = 1U << _INTEROP_ERROR_GROUP_SHIFT,
   INTEROP_ERROR_GROUP_IO           = 2U << _INTEROP_ERROR_GROUP_SHIFT,
   INTEROP_ERROR_GROUP_LICENSE      = 4U << _INTEROP_ERROR_GROUP_SHIFT
};

enum {
   INTEROP_OK                          = 0,

   INTEROP_ERROR_GENERIC               = INTEROP_ERROR_GROUP_GENERIC,
   INTEROP_ERROR_INVALID_OPERATION,
   INTEROP_ERROR_INVALID_PARAMETER,
   INTEROP_ERROR_OUT_OF_RANGE,
   INTEROP_ERROR_UNKNOWN_ENTITY,
   INTEROP_ERROR_UNSUPPORTED_VERSION,
   INTEROP_ERROR_INSUFFICIENT_BUFFER,

   INTEROP_ERROR_IO_GENERIC            = INTEROP_ERROR_GROUP_IO,
   INTEROP_ERROR_IO_NOT_FOUND,
   INTEROP_ERROR_IO_ACCESS_DENIED,
   INTEROP_ERROR_IO_INVALID_LIBRARY,

   INTEROP_ERROR_IO_NO_LICENSE         = INTEROP_ERROR_GROUP_LICENSE,
   INTEROP_ERROR_GUID_NOT_FOUND,
   INTEROP_ERROR_LICENSE_NOT_FOUND,
   INTEROP_ERROR_NO_LICENSE_INFO
};

inline INTEROP_RESULT GetInteropErrorGroup(INTEROP_RESULT _code) { return _code & _INTEROP_ERROR_GROUP_MASK; }

#ifdef __cplusplus
} // extern "C" 
#endif

#endif // ifndef __INTEROP_CODES_H__
